"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fs = require('fs');

var http = require('http');

var URL = require('url');

var AbstractFileReader = require('./AbstractFileReader');

function bufferToArrayBufferSlice(buffer, bytes) {
  var bytesToRead = bytes === undefined ? buffer.byteLength : bytes;
  return buffer.buffer.slice(buffer.byteOffset, buffer.byteOffset + bytesToRead);
}

var LocalFileReader =
/*#__PURE__*/
function (_AbstractFileReader) {
  _inherits(LocalFileReader, _AbstractFileReader);

  function LocalFileReader(path) {
    var _this;

    _classCallCheck(this, LocalFileReader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LocalFileReader).call(this));

    _defineProperty(_assertThisInitialized(_this), "handle", void 0);

    _defineProperty(_assertThisInitialized(_this), "size", void 0);

    _this.handle = fs.openSync(path, 'r');
    _this.size = fs.statSync(path).size;
    return _this;
  }

  _createClass(LocalFileReader, [{
    key: "bytes",
    value: function bytes() {
      var _this2 = this;

      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var length = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        var lengthToRead = length === undefined ? _this2.size - start : length;
        var buffer = Buffer.alloc(lengthToRead);
        fs.read(_this2.handle, buffer, 0, lengthToRead, start, function (err, read, buf) {
          if (err) {
            reject(new Error(err));
          } else {
            resolve(bufferToArrayBufferSlice(buf, read));
          }
        });
      });
    }
  }]);

  return LocalFileReader;
}(AbstractFileReader);

var RemoteFileReader =
/*#__PURE__*/
function (_AbstractFileReader2) {
  _inherits(RemoteFileReader, _AbstractFileReader2);

  function RemoteFileReader(url) {
    var _this3;

    _classCallCheck(this, RemoteFileReader);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(RemoteFileReader).call(this));

    _defineProperty(_assertThisInitialized(_this3), "url", void 0);

    _this3.url = URL.parse(url);
    return _this3;
  }

  _createClass(RemoteFileReader, [{
    key: "bytes",
    value: function bytes() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var length = arguments.length > 1 ? arguments[1] : undefined;
      var options = Object.assign({}, this.url, {
        method: 'GET'
      });

      if (start !== 0 || length !== undefined) {
        // Requesting only a portion of the file
        options.headers = {
          Range: length !== undefined ? "bytes=".concat(start, "-").concat(start + (length - 1)) : "bytes=".concat(start, "-")
        };
      }

      return new Promise(function (resolve, reject) {
        var req = http.request(options, function (res) {
          var data = [];
          res.on('data', function (chunk) {
            data.push(chunk);
          }).on('end', function () {
            var buffer = Buffer.concat(data);
            resolve(bufferToArrayBufferSlice(buffer));
          });
        });
        req.on('error', function (e) {
          reject(new Error("RemoteFileRequest failed: ".concat(e.message)));
        });
        req.end();
      });
    }
  }]);

  return RemoteFileReader;
}(AbstractFileReader);

module.exports = {
  LocalFileReader: LocalFileReader,
  RemoteFileReader: RemoteFileReader
};